/**
   <strong>Clase que contiene una serie de pruebas
   para verificar la funcionalidad de la 
   clase Vector.</strong>
*/
public class testVector {
    /**
       Funcion main que realiza las pruebas.
    */
    public static void main(String[ ] args) {
	/* Vectores y Resultados*/
	
	Vector a = new Vector(3D , 2D);
	Vector b = new Vector(1F , 0.22D);
	Vector c = new Vector();
	Vector r1 = new Vector(7D , 5d);
	Vector r2 = new Vector(1F , 1.52D);
	Vector r3 = new Vector(9D , 6D);
	Vector r4 = new Vector(11.441087F , 0.6582295603756141D);
	Vector r5 = new Vector(10.2519045F , 3.6512063847485607D);
	float r6 = -5.4492316F;

	/*
	  Ejecucion de las pruebas
	*/

	/* Traslacion */
	System.out.println("\n*** TRASLACION ***");
	System.out.println("Vector 1: "+ c.toString() );
	System.out.println("Vector 2: "+ a.toString() );
	c.sumarle(a);
	System.out.println("Resultado: "+ c.toString() );
	printResult( c.equals(r1) ); //indica si paso o no la prueba

	/* Rotacion */
	System.out.println("*** ROTACION ***");
	System.out.println("Vector 1: "+ b.toString() );
	System.out.println("Escalar: 1.3");
	b.rotar(1.3);
	System.out.println("Resultado: "+ b.toString() );
	printResult( b.equals(r2) );

	/* Multiplicacion por escalar */
 	System.out.println("*** MULTIPLICACION ***");
	System.out.println("Vector 1: "+ a.toString() );
	System.out.println("Escalar: 3.0");
	a.multiplicacionPorEscalar(3.0F);
	System.out.println("Resultado: "+ a.toString() );
	printResult( a.equals(r3) );

	/* Suma */
	System.out.println("*** SUMA ***");
	System.out.println("Vector 1: "+ a.toString() );
	System.out.println("Vector 2: "+ b.toString() );
	c = Vector.suma(a,b);
	System.out.println("Resultado: "+ c.toString());
	printResult( c.equals(r4) );

	/* Resta */
	System.out.println("*** RESTA ***");
	System.out.println("Vector 1: "+ b.toString() );
	System.out.println("Vector 2: "+ a.toString() );
	c = Vector.resta(b,a);
	System.out.println("Resultado: "+ c.toString());
	printResult( c.equals(r5) );

	/* Producto Punto */
	System.out.println("*** PRODUCTO PUNTO ***");
	System.out.println("Vector 1: "+ c.toString() );
	System.out.println("Vector 2: "+ b.toString() );
        float d = Vector.productoPunto(c,b);
	System.out.println("Resultado: "+ d);
	printResult( (d==r6) );
    }
     
    
    /**
       Muestra en pantalla el resultado de un "test".
       @param z resultado
       <p>Si el resultado es verdadero, imprime <code>PASSED</code>
       <br>Si es falso, imprime <code>FAILED</code></p>
    */
    private static void printResult(boolean z) {
	if (z==true)
	    System.out.println("\tPASSED\n");
	else
	    System.out.println("\tFAILED\n");
    }

}
